; task: add two 16 bit numbers
; input on paper:
;  4..7:  op1, MSB
;  8..11: op2, MSB
;
; output on paper:
;  0..3: sum, MSB

	BTS STATUS, 3   ; SI: paper
	BTC STATUS, 2   ; DI: ram

	; set SI to 4
	LDA 4
	MOVE SI, A

	; add both operands to ram
	CALL sum
	CALL sum


	CALL count4_di0

	; copy ram 0..3 on paper
	BTC STATUS, 3   ; SI: ram
	BTS STATUS, 2   ; DI: paper

	MOVE SI, A

@copy:
	LDAS
	STAD
	LOOPI
	JMP copy
	FIN

; load counter with constant 4, set DI and A to 0 - assumes DI pointing to RAM
@count4_di0:
	LDA 6
	MOVE DI, A
	LDA 4
	STAD
	LDA 0
	MOVE DI, A
	RET

; add 16 bits at SI to ram 0
@sum:
	CALL count4_di0
@sum2:
	ADDSDC
	LOOPI
	JMP sum2
	RET
